﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.IO;
using System.IO.Ports;
using System.Threading;

namespace SCILoader240
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        byte[] HexStringToByteArray(string s)
        {
            byte[] buffer = new byte[s.Length / 2];
            for (int i = 0; i < s.Length; i += 2)
                buffer[i / 2] = (byte)Convert.ToByte(s.Substring(i, 2), 16);
            return buffer;
        }

         void Th2()
        {
            int i;
             // ждем обратный символ
            i = serialPort1.ReadByte();
            
            if (i == 170) { MessageBox.Show("Программа успешно загружена!");}
            else { MessageBox.Show("Принят неверный символ!");}
        }
        
        // Кнопка отправить 
        private void button1_Click(object sender, EventArgs e)
        {
            byte[] b; // Массив байт для передачи
            string s;
            var t = new Thread(Th2);           
            int size, i=1; // Размер блока и счетчик строк
            // Инициализация параметров порта
            serialPort1.PortName = comboBox1.Text;
            serialPort1.BaudRate = Convert.ToInt32(comboBox2.Text, 10);  
            serialPort1.Open();

            s = richTextBox1.Lines[0];
            b = HexStringToByteArray(s);
            serialPort1.Write(b, 0, 2); // Отправка точки входа в программу          

            // Считываем размер очередного блока
            if (i <= richTextBox1.Lines.Count()){
            s = richTextBox1.Lines[i];}
            i++;
            size=Convert.ToInt32(s, 16);
            while (size != 0)
            {
                b = HexStringToByteArray(s);
                //MessageBox.Show(s + "Размер блока");
                serialPort1.Write(b, 0, 2); // Отправка размера блока               
                if (i <= richTextBox1.Lines.Count())
                {
                    s = richTextBox1.Lines[i];
                }
                b = HexStringToByteArray(s);
                //MessageBox.Show(s + "Adr блока");
                serialPort1.Write(b, 0, 2); // Отправка адреса блока
                i++;
                if (i <= richTextBox1.Lines.Count())
                {
                    s = richTextBox1.Lines[i];
                }
                b = HexStringToByteArray(s);
                //MessageBox.Show(s + "Память");
                serialPort1.Write(b, 0, 2); // Отправка типа памяти
                i++;
                // Отправка блока
                for (int j = 0; j < size; j++)
                {
                    if (i <= richTextBox1.Lines.Count())
                    {
                        s = richTextBox1.Lines[i];
                    }
                    b = HexStringToByteArray(s);
                    //MessageBox.Show(s + "Данные");
                    serialPort1.Write(b, 0, 2); // Отправка типа памяти
                    i++;
                }
                if (i <= richTextBox1.Lines.Count())
                {
                    s = richTextBox1.Lines[i];
                }
                size = Convert.ToInt32(s, 16);
                //MessageBox.Show(size.ToString());
                i++;
            }
            b = HexStringToByteArray(s);
            serialPort1.Write(b, 0, 2); // Отправка 0000

            t.Start(); // прием символа в отдельном потоке
            // ждем обратный символ
            //i = serialPort1.ReadByte();
            //richTextBox1.Clear();
            //if (i == 170) { richTextBox1.AppendText("Программа успешно загружена!");} 
            //else { richTextBox1.AppendText("Принят неверный символ!");}

        }

        private void Form1_Load(object sender, EventArgs e)
        {
            string[] ports = SerialPort.GetPortNames();          
            if (ports.Length > 0)
            {
                foreach (string port in ports)
                {
                    comboBox1.Items.Add(port);
                }
                comboBox1.Text = ports[0];
                
            }
            else
            {
                comboBox1.Text = "Нет доступных портов";
                button1.Enabled = false;
                button2.Enabled = false;
            }
            comboBox2.Text=comboBox2.Items[11].ToString();
            richTextBox1.AppendText("Выберете файл с программой для загрузки.");
        }

        // Кнопка Открыть Файл 
        private void button2_Click(object sender, EventArgs e)
        {
            string[] temp_m;               
            openFileDialog1.ShowDialog();
            if (File.Exists(openFileDialog1.FileName))
            {
                temp_m = File.ReadAllLines(openFileDialog1.FileName);
                richTextBox1.Lines=temp_m;
                button1.Enabled = true;
            }
            else
            {
                richTextBox1.Clear();
                richTextBox1.AppendText("Файл программой для загрузки не выбран!");
                
            }
        }

        private void button3_Click(object sender, EventArgs e)
        {

        }

        private void Form1_Resize(object sender, EventArgs e)
        {


            richTextBox1.Height = (Size.Height - panel1.Height-30);
        }
    }
}
